(*
This demo makes use of a couple of interesting hacks to fully
customize API messageboxes.  You can modify fonts, button
captions and even change the icon to your application's icon
without adding a byte of extra resource data to your project.

This demo uses the forms unit.

It adds a nice touch and makes WINCIM's connection messagebox,
which was my inspiration, look positively primitive. (WINCIM
uses a resource to draw the messagebox...sorry folks but I
couldn't resist loading it into Resource Workshop to find out
for sure.)

Oh, and does it work in 32 bit?  Ahem...well...actually this
project was converted *backward* from a 32 bit project.

's Lea'sware from Cub

cublea@cyberstore.ca

Totally use-at-your-own-risk stuff.

*)

unit Unit1;

interface

uses
  Winprocs, wintypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
	Button1: TButton;
	Button2: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }

{In forms-based units, we can set up a procedure to handle a specific
 message received by the form window.  We needed to process the info
 in the dialog callback function in GENERIC.DPR...doing this in a form
 is considerably less confusing.

 Note the function declaration...I'd never seen a declaration like this
 before. I assume it predeclares Msg as WM_USER+1024, but how this
 actually triggers the procedure to execute is beyond me. Hey, this is
 Delphi...if it works, why delve deeper?}

  procedure pmChangeMessageBox ( var Msg: TMessage ); message WM_USER + 1024;
  public
	{ Dclarations publiques }
  end;

var
  Form1: TForm1;
const ItemID: Integer = 0;


implementation


procedure TForm1.pmChangeMessageBox ( var Msg: TMessage );
var MsgboxHwnd: HWND;
	Fonthandle:HFont;
	DlgFont:TLOGFONT;
	NewFont: HFont;
	NewIcon : THandle;
begin
{Now, when we fetch the messagebox windowhandle, we need to know its
 caption when using FindWindow. There's probably another way; I don't know it.
 The original author used FindWindow(MAKEINTRESOURCE(WC_DIALOG), 'caption')
 to insure that only dialog windows were polled by FindWindow, but when I
 tried FindWindow(nil,'My Message Caption') it worked just as well.}
	MsgboxHwnd := FindWindow(MAKEINTRESOURCE(WC_DIALOG), 'caption');
	if (MsgboxHwnd <> 0) then begin
{First let's mess with the button caption text.}
		SetDlgItemText(
			Msgboxhwnd,
			ID_OK {the ID number of the OK button},
			'Don''t press me' {the new button captio}
			);
{You could also modify the Cancel button text by specifying ID_CANCEL
	in another SetDlgItemText() command.}

{Now let's modify a button font.}
		Fonthandle := SendMessage(MsgboxHwnd,WM_GETFONT,0,0);
		GetObject(Fonthandle,sizeof(TLOGFONT), @Dlgfont);
		strpcopy(Dlgfont.lfFaceName,'Times');
{ You can also try messing with any other TLOGFONT characteristics.}
{			Dlgfont.lfClipPrecision := CLIP_LH_ANGLES or CLIP_TT_ALWAYS;
			Dlgfont.Lfweight := FW_BOLD;
			DlgFont.lfheight:= 25;
			Dlgfont.lfwidth:= 7;}
		NewFont := CreateFontIndirect(DlgFont);
		If NewFont <> 0 then SendDlgItemMessage(Msgboxhwnd,ID_OK,WM_SETFONT,NewFont,0);
{Finally let's apply the application's icon to the messagebox.
 Delphi uses MAINICON as the default. You can specify other icons in your app's
 resources as well. The hard part of this was finding the messagebox item ID for
 the icon. I hacked a little test program together and discovered by trial-and-
 error that its ID is 10.  (Sometimes you get lucky that way...it could have been
 1024, and I was incrementing by 1's when inputting sequential item IDs.)}
		NewIcon := LoadIcon(hinstance,'MAINICON');
		If Newicon <> 0 Then SendDlgItemMessage(Msgboxhwnd,10,STM_SETICON,NewIcon,0);
	end;
end;



{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  PostMessage(Handle, WM_USER + 1024, 0, 0);
  MessageBox(Handle, 'message', 'caption', MB_OKCancel or MB_ICONQUESTION);
end;

end.
